# Paper Results

This folder presents the actual results used in PacketMill [paper][packetmill-paper]. 

## Content

Each folder contains the following files/folder:

- `Makefile`: Can be used to replot the same figures used in our paper.
- `csv` folder: Contains the csv files generated by NPF tool.
- `pdf` folder: Contains the pdf files generated by NPF tool.
- `transpose.sh`: A bash script for processing the csv files. 
- `plot.gp`: A gnuplot script for plotting the figures.
- PDF files generated by the gnuplot.

Note that you need `csvtools` and `gnuplot` to replot the results. You can install them as follows:

```bash
sudo apt-get install csvtool gnuplot
```

## Experiments

The following list summarizes the scenario/experiment for the available results:

- `dual_NIC_fwd`: Compares the performance of different metadata management models when a single core forwards mixed-size packets received via two NICs.
- `lto_router`: Shows the impact of using LTO and our reordering (LLVM) pass on a router fowarding mixed-size packets with a single core.
- `packetmill_ids`: Shows the impact of applying PacketMill to a router+IDS+VLAN.
-  `packetmill_nat`: Shows the impact of applying PacketMill to a multicore router+NAT.
-  `packetmill_router_rate`: Shows the impact of applying PacketMill to a router when receiving mixed-size packets at different rates.
-  `packetmill_router_wp_5`: Shows the impact of applying PacketMill to an emulated network function that performs 5 accesses per packet.
-  `packetmill_router_wp_10`: Shows the impact of applying PacketMill to an emulated network function that performs 5 accesses per packet.
-  `packetmill_router_wp_detailed`: Shows the impact of applying PacketMill to an emulated network function that performs different number of accesses per packet. This folder contains 3D figures generated by MATLAB.
- `source_code_router`: Compares the impact of different source-code modifications done by PacketMill while a single core runs a router configuration and forward mixed-size packets.
- `xchg_fwd`: Compares the performance of different metadata management models when a single core forwards mixed-size packets received via one NIC.

[packetmill-paper]: https://people.kth.se/~farshin/documents/packetmill-asplos21.pdf